var OPEN_ITEM = "Open";
var SPLASH_IMAGE = "icons/icon_032.png";
var SYSTRAY_TOOLTIP = "Sticky Notes";
var EXIT_ITEM = "Exit";

function doClosing(evt) {
  var answer = null;
  // Stop the default of actually closing the window
  evt.preventDefault();
  
  // Ask the user what action to take
  answer = confirm("Select \"OK\" to exit or \"Cancel\" to minimize.");
  if(answer) {
    // If they actually want to close the application
    closeApplication();
  }
  else {
    // If they really just want to minimize the window
    dock();
  }
  
  // Dock application by default, uncomment the above lines for an option
  // dock();
}

function doLoaderComplete(evt) {
  var isMac = null;
  // Get the bitmap data (pixels) of the icon for the system
  // The system will size and convert to the appropriate format
  imgDock = evt.target.content.bitmapData;

  if(air.NativeApplication.supportsSystemTrayIcon) {
    // Setup Windows specific system tray functionality
    air.NativeApplication.nativeApplication.icon.tooltip = SYSTRAY_TOOLTIP;
    air.NativeApplication.nativeApplication.icon.addEventListener('click', doTrayClick);
    isMac = false;
  } 
  else {
    isMac = true;
  }
  // Override the default minimize behavior and use our own
  nativeWindow.addEventListener(air.NativeWindowDisplayStateEvent.DISPLAY_STATE_CHANGING, doStateChange);
  // Setup a menu on the docked icon to restore or close
  air.NativeApplication.nativeApplication.icon.menu = createMenu(isMac);
}

function doOpenSelect(evt) {
  undock();
}

function doStateChange(evt) {
  if(evt.afterDisplayState == air.NativeWindowDisplayState.MINIMIZED) {
    // Stop the default behavior
    // Call shared function to systray/dock
    evt.preventDefault();
    dock();
  }
}

function doTrayClick(evt) {
  undock();
}

function closeApplication() {
  nativeWindow.close();
}

function createMenu(isMac) {
  var menu = new air.NativeMenu();
  var openItem = new air.NativeMenuItem(OPEN_ITEM);
  var exitItem = null;
  // Both operating systems have an option to open the window
  openItem.addEventListener(air.Event.SELECT, doOpenSelect);
  menu.addItem(openItem);
  if(!isMac) {
    // Mac provides built-in "Quit" item
    // Create an "Exit" item for Windows
    exitItem = new air.NativeMenuItem(EXIT_ITEM);
    exitItem.addEventListener(air.Event.SELECT, closeApplication);
    menu.addItem(exitItem);
  }
  return menu;
}

function dock() {
  nativeWindow.visible = false;
  air.NativeApplication.nativeApplication.icon.bitmaps = [imgDock];
}

function undock() {
  // Show the window and bring it to the front
  nativeWindow.visible = true;
  nativeWindow.orderToFront();
  
  // Clear out the systray/dock icon (optional)
  air.NativeApplication.nativeApplication.icon.bitmaps = [];
}
