var pr = {
	appdir: 'SEOAnalyzer',
	applog: 'SEOAnalyzer/logger.log',
	versionfile: 'http://abhinavsingh.com/seoanalyzer/version.txt',
	version: 1.2,
	cachetime: 604800, // 1 week
	versionfilecachetime: 86400, // 1 day
	yahooappid: 'C_fFxSzV34GBJwTtxg3YpcouovCI3FGsukmPYXVr0bGqelxRPnJi9MmY_7fcrQLBSMlQHetgxANcyph0LA--',
	bingappid: '1C79F5B654A2D9E8350D066433A0B8356BCACBC9',
	tmpid: '',
	update: function() {
		var str = pr.cacheexists(pr.versionfile,pr.versionfilecachetime);
		if (str) {
			pr.logger("Older version file found, no updates");
		}
		else {
			var req = new XMLHttpRequest();
			req.onreadystatechange = function(){
				if (req.readyState == 4) {
					var str = req.responseText;
					pr.fwrite(pr.appdir+"/"+md5(pr.versionfile)+".rss", str, 'WRITE');
					pr.logger("New version file has version: " + str);
					if (str > pr.version) {
						document.getElementById('updatemessage').innerHTML = 'Update to v ' + str;
						document.getElementById('updatemessage').style.display = 'block';
					}
				}
			}
			req.open('GET', pr.versionfile, true);
			req.send(null);
		}
	},
	setup: function() {
		// Run updater
		this.update();
		
		// Run doc in doc out setup
		var loader = new air.Loader();
		loader.contentLoaderInfo.addEventListener(air.Event.COMPLETE, doLoaderComplete);
		loader.load(new air.URLRequest(SPLASH_IMAGE));
		nativeWindow.addEventListener(air.Event.CLOSING, doClosing);
		
		// Check for app directories
		var dir = air.File.userDirectory.resolvePath(this.appdir);
		if (!dir.exists) {
			this.logger("Create App Directory");
			dir.createDirectory();
		}
		else {
			this.logger("App Directory already exists");
		}
	},
	zeroFill: function(a, b){
		z = hexdec(80000000);
		if (z & a) {
			a = (a >> 1);
			a &= (~ z);
			a |= 0x40000000;
			a = (a >> (b - 1));
		}
		else {
			a = (a >> b);
		}
		return a;
	},
	mix: function(a, b, c){
		a -= b; a -= c; a ^= (this.zeroFill(c, 13));
		b -= c; b -= a; b ^= (a << 8);
		c -= a; c -= b; c ^= (this.zeroFill(b, 13));
		a -= b; a -= c; a ^= (this.zeroFill(c, 12));
		b -= c; b -= a; b ^= (a << 16);
		c -= a; c -= b; c ^= (this.zeroFill(b, 5));
		a -= b; a -= c; a ^= (this.zeroFill(c, 3));
		b -= c; b -= a; b ^= (a << 10);
		c -= a; c -= b; c ^= (this.zeroFill(b, 15));
		return new Array(a, b, c);
	},
	ch: function(url){
		length = sizeof(url);
		a = 0x9E3779B9;
		b = 0x9E3779B9;
		c = 0xE6359A60;
		k = 0;
		len = length;
		while (len >= 12) {
			a += (url[k + 0] + (url[k + 1] << 8) + (url[k + 2] << 16) + (url[k + 3] << 24));
			b += (url[k + 4] + (url[k + 5] << 8) + (url[k + 6] << 16) + (url[k + 7] << 24));
			c += (url[k + 8] + (url[k + 9] << 8) + (url[k + 10] << 16) + (url[k + 11] << 24));
			m = this.mix(a, b, c);
			a = m[0]; b = m[1]; c = m[2];
			k += 12;
			len -= 12;
		}
		c += length;
		switch (len) {
			case 11: c += (url[k + 10] << 24);
			case 10: c += (url[k + 9] << 16);
			case 9:  c += (url[k + 8] << 8);
			case 8:  b += (url[k + 7] << 24);
			case 7:  b += (url[k + 6] << 16);
			case 6:  b += (url[k + 5] << 8);
			case 5:  b += (url[k + 4]);
			case 4:  a += (url[k + 3] << 24);
			case 3:  a += (url[k + 2] << 16);
			case 2:  a += (url[k + 1] << 8);
			case 1:  a += (url[k + 0]);
		}
		m = this.mix(a, b, c);
		return m[2];
	},
	strord: function(string){
		var result = new Array();
		for (i = 0; i < strlen(string); i++) {
			result[i] = ord(string[i]);
		}
		return result;
	},
	gethash: function(url) {
		return this.ch(this.strord("info:" + url));
	},
	getpr: function(baseurl) {
		var query = "";
		query += "http://toolbarqueries.google.com/search";
		query += "?client=navclient-auto";
		query += "&hl=en";
		query += "&ch=6"+pr.gethash(baseurl);
		query += "&ie=UTF-8";
		query += "&oe=UTF-8";
		query += "&features=Rank";
		query += "&q=info:"+baseurl;
		
		var str = pr.cacheexists(query,pr.cachetime);
		if (str) {
			var pagerank = substr(str, 9, 1);
			pr.displaypr(pagerank, baseurl);
		}
		else {
			var req = new XMLHttpRequest();
			req.onreadystatechange = function(){
				if (req.readyState == 4) {
					var str = req.responseText;
					pr.fwrite(pr.appdir+"/"+md5(query)+".rss",str,'WRITE');
					var pagerank = substr(str, 9, 1);
					pr.displaypr(pagerank, baseurl);
				}
			}
			req.open('GET', query, true);
			req.send(null);
		}
	},
	displaypr: function(pagerank,baseurl) {
		if (pagerank != '') {
			document.getElementById(pr.tmpid).innerHTML = '<b>Site PR:</b> ' + pagerank;
		}
		else {
			document.getElementById(pr.tmpid).innerHTML = '<b>Site PR:</b> NA';
		}
	},
	getbacklink: function(url) {
		var rss = "";
		rss += "http://blogsearch.google.com/blogsearch_feeds";
		rss += "?hl=en";
		rss += "&scoring=d";
		rss += "&q=link:"+url;
		rss += "&ie=utf-8";
		rss += "&num=100";
		rss += "&output=rss";
		
		var str = pr.cacheexists(rss,pr.cachetime);
		if (str) {
			pr.displaybacklink(str);
		}
		else {
			var req = new XMLHttpRequest();
			req.onreadystatechange = function(){
				if (req.readyState == 4) {
					var str = req.responseText;
					pr.fwrite(pr.appdir+"/"+md5(rss)+".rss",str,'WRITE');
					pr.displaybacklink(str);
				}
			}
			req.open('GET', rss, true);
			req.send(null);
		}
	},
	displaybacklink: function(rss) {
		var xmlobject = (new DOMParser()).parseFromString(rss, "text/xml");
		var root = xmlobject.getElementsByTagName('rss')[0];
		var channels = root.getElementsByTagName("channel");
		var items = channels[0].getElementsByTagName("item");
		var html = '<ul>';
		for(var i=0;i<items.length;i++) {
			var title = (items[i].getElementsByTagName("title"))[0].firstChild.nodeValue;
			var link = (items[i].getElementsByTagName("link"))[0].firstChild.nodeValue;
			var description = (items[i].getElementsByTagName("description"))[0].firstChild.nodeValue;
			var feedid = md5(link);
			html += '	<li id="'+feedid+'" name="feeds">';
			html += '		<table cellspacing="0" cellpadding="0" border="0">';
			html += '			<tr>';
			html += '				<td class="serial">';
			html += '					<img id="'+feedid+'_icon" src="/icons/expand.gif"/>';
			html += '				</td>';
			html += '				<td class="backlink">';
			html += 					title;
			html += '				</td>';
			html += '			</tr>';
			html += '		</table>';
			html += '		<table cellspacing="0" cellpadding="0" border="0" class="details" id="'+feedid+'_details" style="display:none">';
			html += '			<tr>';
			html += '				<td class="link">';
			html +=	'					<a href="javascript:void(0)" id="'+feedid+'_link">'+link+'</a>';
			html += '				</td>';
			html += '			</tr>';
			html += '			<tr>';
			html += '				<td class="description">';
			html +=						description;
			html += '				</td>';
			html += '			</tr>';
			html += '			<tr>';
			html += '				<td class="pagehreftag">';
			html +=	'					<p id="'+feedid+'_href"><b>Anchor Tag:</b> Loading...</p>';
			html += '				</td>';
			html += '			</tr>';
			html += '			<tr>';
			html += '				<td class="pagerank">';
			html +=	'					<p id="'+feedid+'_pr"><b>Site PR:</b> Loading...</p>';
			html += '				</td>';
			html += '			</tr>';
			html += '		</table>';
			html += '	</li>';
		}
		html += '</ul>';
		
		if(items.length == 0) {
			html = '<center style="margin-top:50px;" id="status">';
			html += 'OOPS! No backlinks for the site';
			html += '</center>';
		}
		
		document.getElementById('backlinks').innerHTML = html;
		
		pr.attachEvents();
	},
	attachEvents: function() {
		var feeds = document.getElementsByName("feeds");
		for(var i=0;i<feeds.length;i++) {
			document.getElementById(feeds[i].id+'_icon').addEventListener('click', function(){
				if(document.getElementById((this.id).replace("_icon","_details")).style.display == "none") {
					document.getElementById(this.id).src = '/icons/collapse.gif';
					document.getElementById((this.id).replace("_icon","_details")).style.display = 'block';
					
					pr.tmpid = (this.id).replace("_icon","_pr");
					pr.getpr(pr.getbasedomain(document.getElementById((this.id).replace("_icon","_link")).innerHTML));
					pr.getbacklinkhreftag((this.id).replace("_icon","_href"),document.getElementById((this.id).replace("_icon","_link")).innerHTML);
				}
				else {
					document.getElementById(this.id).src = '/icons/expand.gif';
					document.getElementById((this.id).replace("_icon","_details")).style.display = 'none';					
				}
			});
			
			document.getElementById(feeds[i].id+'_link').addEventListener('click', function(){
				pr.openinbrowser(document.getElementById((this.id).replace("_icon","_link")).innerHTML);
			});
		}
	},
	getbacklinkhreftag: function(id,url) {
		// Fetch the particular webpage
		var base = document.getElementById('url').value;
		base = pr.getbasedomain(base);
		base = base.replace("http://","");
		base = base.replace("www.","");
		base = base.replace("/","");
		
		var str = pr.cacheexists(url,pr.cachetime);
		if (str) {
			// Find the particular backlink href tag
			var reg = /<a[^>]+href="([^"]+)"[^>]*>/ig;
			var match = str.match(reg);
			for(var i=0;i<match.length;i++) {
				if(strstr(match[i],base)) {
					var tag = match[i];
					tag = tag.replace(/</g,"&lt;");
					tag = tag.replace(/>/g,"&gt;");
					document.getElementById(id).innerHTML = "<b>Anchor Tag:</b> "+tag;
				}
			}
		}
		else {
			var req = new XMLHttpRequest();
			req.onreadystatechange = function(){
				if (req.readyState == 4) {
					var str = req.responseText;
					str = str.replace(/'/g,'"');
					pr.fwrite(pr.appdir+"/"+md5(url)+".rss",str,'WRITE');
					
					// Find the particular backlink href tag
					var reg = /<a[^>]+href="([^"]+)"[^>]*>/ig;
					var match = str.match(reg);
					for(var i=0;i<match.length;i++) {
						if(strstr(match[i],base)) {
							var tag = match[i];
							tag = tag.replace(/</g,"&lt;");
							tag = tag.replace(/>/g,"&gt;");
							document.getElementById(id).innerHTML = "<b>Anchor Tag:</b> " + tag;
						}
					}
				}
			}
			req.open('GET', url, true);
			req.send(null);
		}
	},
	getbasedomain: function(url) {
		if(substr(url,-1,1) != '/') {
			url += '/';
		}
		var baseurl = url.substring(0, url.indexOf('/', 14));
		return baseurl + "/";
	},
	cacheexists: function(url,cachetime) {
		var cacheurl = this.appdir+"/"+md5(url)+".rss";		
		var cachefile = air.File.documentsDirectory.resolvePath(cacheurl);
		if (cachefile.exists) {
			var cacheage = this.dateDiff(cachefile.modificationDate);
			if (cacheage < cachetime) {
				this.logger(base64_encode(url)+" \nfound in cache");
				//this.logger(url+" \nfound in cache");
				return this.fread(cacheurl,'READ');
			}
			else {
				this.logger(base64_encode(url)+" \nfound in cache, but expired");
				//this.logger(url+" \nfound in cache, but expired");
				return false;
			}
		}
		else {
			//this.logger(base64_encode(url)+" \nnot found in cache");
			this.logger(url+" \nnot found in cache");
			return false;
		}
	},
	fread: function(location, mode) {
		var file = air.File.applicationStorageDirectory.resolvePath(air.File.documentsDirectory.resolvePath(location).url);
		var fileStream = new air.FileStream();
		if(mode == 'READ') fileStream.open(file, air.FileMode.READ);
		var xml = fileStream.readUTFBytes(fileStream.bytesAvailable);
		fileStream.close();
		return xml;
	},
	fwrite: function(location, data, mode) {
		var file = air.File.documentsDirectory.resolvePath(location);
		var fileStream = new air.FileStream();
		if(mode == 'APPEND') fileStream.open(file, air.FileMode.APPEND);
		else if(mode == 'WRITE') fileStream.open(file, air.FileMode.WRITE);
		fileStream.writeUTFBytes(data);
		fileStream.close();
	},
	dateDiff: function(d) {
		return this.date2epoch('')-this.date2epoch(d);
	},
	date2epoch: function(d) {
		if(d == '') var date = new Date();
		else var date = new Date(d);
		return date.getTime()/1000.0;
	},
	logger: function(log) {
		var now = new Date();
		var timestamp = now.getFullYear()+"-"+now.getMonth()+"-"+now.getDate()+" "+now.getHours()+":"+now.getMinutes()+":"+now.getSeconds();
		
		var logfile = air.File.documentsDirectory.resolvePath(this.applog);
		if(!logfile.exists) this.fwrite(this.applog, timestamp+'\n'+'Successfully Created Logger File'+'\n\n', 'WRITE');
		
		this.fwrite(this.applog, timestamp+'\n'+log+'\n\n', 'APPEND');
	},
	expand: function(id) {
		document.getElementById(id+'_details').style.display = 'block';
	},
	openinbrowser: function(url) {
		air.navigateToURL( new air.URLRequest(url)); 
	},
	backlinks: function() {
		// Get parameters
		var url = document.getElementById('url').value;
		var keyword = document.getElementById('keyword').value;
		
		// Exit if no url entered
		if(url == '' || url == 'http://') {
			alert("Enter a site url to start analysis");
			return false;
		}
		
		// Make the right menu visible
		//if(keyword == 'Enter comma seperated keyword(s)' || keyword == '') {
		if(keyword == '') {
			document.getElementById('singlemenu').style.display = 'block';
			document.getElementById('doublemenu').style.display = 'none';
			document.getElementById('smbl').className = "selected";
			document.getElementById('backlinks').style.display = "block";
			document.getElementById('pageranks').style.display = "none";
		}
		else {
			document.getElementById('singlemenu').style.display = 'none';
			document.getElementById('doublemenu').style.display = 'block';
			document.getElementById('dmbl').className = "selected";
			document.getElementById('backlinks').style.display = "block";
			document.getElementById('dmpr').className = "";
			document.getElementById('pageranks').style.display = "none";
		}
		
		// Hide the opening message item
		document.getElementById('message').style.display = 'none';
		
		// Set the loading image
		document.getElementById('backlinks').style.display = 'block';
		document.getElementById('backlinks').innerHTML = '<center style="margin-top:50px;" id="status"><img src="/icons/loading.gif"/></center>';
		
		// Get google PR
		pr.tmpid = 'pr';
		pr.getpr(url);
		
		// Get back links
		pr.getbacklink(url);
	},
	googlerank: function(keyword,base) {
		base = pr.getbasedomain(base);
		base = base.replace("http://","");
		base = base.replace("www.","");
		base = base.replace("/","");
		
		document.getElementById('googleservice_keyword_'+keyword).innerHTML = keyword;
		document.getElementById('googleservice_rank_'+keyword).innerHTML = "Loading...";
		document.getElementById('googleservice_href_'+keyword).innerHTML = "Loading...";
		
		var gpr = "http://www.google.com/ie?q="+keyword+"&num=100&gl=US&pws=0";
		var str = pr.cacheexists(gpr,pr.cachetime);
		if (str) {
			pr.handlegooglerank(str,base,keyword);
		}
		else {
			var req = new XMLHttpRequest();
			req.onreadystatechange = function(){
				if (req.readyState == 4) {
					var str = req.responseText;
					str = str.replace(/'/g,'"');
					pr.fwrite(pr.appdir+"/"+md5(gpr)+".rss",str,'WRITE');
					
					pr.handlegooglerank(str,base,keyword);
				}
			}
			req.open('GET', gpr, true);
			req.send(null);
		}
	},
	handlegooglerank: function(str,base,keyword) {
		// Get all links from the page
		var reg = /<a[^>]*>/ig;
		var match = str.match(reg);
		var found = false;
		for(var i=0;i<match.length;i++) {
			var href = match[i];
			if(!strpos(href,"title")) { // title tag not present
				
			}
			else if(strpos(href,"title") < strpos(href,"href")) { // title tag present but before href tag
				var newreg = /<a title=(.*) href=(.*)>/i;
				var newmatch = href.match(newreg);
				if(strstr(newmatch[2],base)) {
					var html = '';
					html += '<b>Title:</b> '+newmatch[1]+'<br/>';
					html += '<b>Link:</b> '+newmatch[2];
					document.getElementById('googleservice_href_'+keyword).innerHTML = html;
					document.getElementById('googleservice_rank_'+keyword).innerHTML = i;
					found = true;
					i = match.length;
				}
			}
			else { // href tag before title tag
				
			}
		}
		if(found == false) {
			document.getElementById('googleservice_keyword_'+keyword).innerHTML = keyword;
			document.getElementById('googleservice_rank_'+keyword).innerHTML = "> 100";
			document.getElementById('googleservice_href_'+keyword).innerHTML = "N.A.";
		}
	},
	yahoorank: function(keyword,base) {
		base = pr.getbasedomain(base);
		base = base.replace("http://","");
		base = base.replace("www.","");
		base = base.replace("/","");
		
		document.getElementById('yahooservice_keyword_'+keyword).innerHTML = keyword;
		document.getElementById('yahooservice_rank_'+keyword).innerHTML = "Loading...";
		document.getElementById('yahooservice_href_'+keyword).innerHTML = "Loading...";
		
		var ypr = "http://api.search.yahoo.com/WebSearchService/V1/webSearch?results=50&appid="+pr.yahooappid+"&query="+keyword+"&start=0&region=us";
		var str = pr.cacheexists(ypr,pr.cachetime);
		if (str) {
			pr.handleyahoorank(str,base,keyword);
		}
		else {
			var req = new XMLHttpRequest();
			req.onreadystatechange = function(){
				if (req.readyState == 4) {
					var str = req.responseText;
					str = str.replace(/'/g,'"');
					pr.fwrite(pr.appdir+"/"+md5(ypr)+".rss",str,'WRITE');
					
					pr.handleyahoorank(str,base,keyword);
				}
			}
			req.open('GET', ypr, true);
			req.send(null);
		}
	},
	handleyahoorank: function(str,base,keyword) {
		// Get all result nodes
		var reg = /<ClickUrl>[^>]*<\/ClickUrl>/ig;
		var match = str.match(reg);
		var found = false;
		for(var i=0;i<match.length;i++) {
			if(strstr(match[i],base)) {
				var html = '';
				html += '<b>Link:</b> '+match[i];
				document.getElementById('yahooservice_href_'+keyword).innerHTML = html;
				document.getElementById('yahooservice_rank_'+keyword).innerHTML = i+1;
				found = true;
				i = match.length;
			}
		}
		if(found == false) {
			document.getElementById('yahooservice_keyword_'+keyword).innerHTML = keyword;
			document.getElementById('yahooservice_rank_'+keyword).innerHTML = "> 50";
			document.getElementById('yahooservice_href_'+keyword).innerHTML = "N.A.";
		}
	},
	bingrank: function(keyword,base) {
		base = pr.getbasedomain(base);
		base = base.replace("http://","");
		base = base.replace("www.","");
		base = base.replace("/","");
		
		document.getElementById('bingservice_keyword_'+keyword).innerHTML = keyword;
		document.getElementById('bingservice_rank_'+keyword).innerHTML = "Loading...";
		document.getElementById('bingservice_href_'+keyword).innerHTML = "Loading...";
		
		var bpr = "http://api.search.live.net/xml.aspx?AppId="+pr.bingappid+"&Query="+keyword+"&Sources=web&web.count=50";
		var str = pr.cacheexists(bpr,pr.cachetime);
		if (str) {
			pr.handlebingrank(str,base,keyword);
		}
		else {
			var req = new XMLHttpRequest();
			req.onreadystatechange = function(){
				if (req.readyState == 4) {
					var str = req.responseText;
					str = str.replace(/'/g,'"');
					pr.fwrite(pr.appdir+"/"+md5(bpr)+".rss",str,'WRITE');
					
					pr.handlebingrank(str,base,keyword);
				}
			}
			req.open('GET', bpr, true);
			req.send(null);
		}
	},
	handlebingrank: function(str,base,keyword) {
		// Get all result nodes
		var reg = /<web:Url>[^>]*<\/web:Url>/ig;
		var match = str.match(reg);
		var found = false;
		for(var i=0;i<match.length;i++) {
			if(strstr(match[i],base)) {
				var html = '';
				html += '<b>Link:</b> '+match[i];
				document.getElementById('bingservice_href_'+keyword).innerHTML = html;
				document.getElementById('bingservice_rank_'+keyword).innerHTML = i+1;
				found = true;
				i = match.length;
			}
		}
		if(found == false) {
			document.getElementById('bingservice_keyword_'+keyword).innerHTML = keyword;
			document.getElementById('bingservice_rank_'+keyword).innerHTML = "> 50";
			document.getElementById('bingservice_href_'+keyword).innerHTML = "N.A.";
		}
	},
	showprdetails: function(t) {
		if (document.getElementById((t.id).replace("_icon", "_details")).style.display == "none") {
			document.getElementById(t.id).src = '/icons/collapse.gif';
			document.getElementById((t.id).replace("_icon","_details")).style.display = 'block';
		}
		else {
			document.getElementById(t.id).src = '/icons/expand.gif';
			document.getElementById((t.id).replace("_icon","_details")).style.display = 'none';
		}
	},
	pageranks: function() {
		// Get parameters
		var url = document.getElementById('url').value;
		var keywords = document.getElementById('keyword').value;
		document.getElementById('rankresults').innerHTML = '';
		
		// Add <li>'s corresponding to each comma seperated keyword
		var keyword = keywords.split(",");
		for(var i=0;i<keyword.length;i++) {
			var html = '';
			html += '<li>';
			html += '	<table cellspacing="0" cellpadding="0" border="0">';
			html += '		<tr>';
			html += '			<td class="serial">';
			html += '				<img name="service_icon" id="googleservice_icon_'+keyword[i]+'" src="/icons/expand.gif"/>';
			html += '			</td>';
			html += '			<td class="service">Google</td>';
			html += '			<td class="keyword">';
			html += '				<p id="googleservice_keyword_'+keyword[i]+'"></p>';
			html += '			</td>';
			html += '			<td class="rank">';
			html += '				<p id="googleservice_rank_'+keyword[i]+'"></p>';
			html += '			</td>';
			html += '		</tr>';
			html += '	</table>';
			html += '	<table cellspacing="0" cellpadding="0" border="0" class="details" id="googleservice_details_'+keyword[i]+'" style="display:none">';
			html += '		<tr>';
			html += '			<td class="link">';
			html += '				<div id="googleservice_href_'+keyword[i]+'">';
			html += '				</div>';
			html += '			</td>';
			html += '		</tr>';
			html += '	</table>';
			html += '</li>';
			html += '<li>';
			html += '	<table cellspacing="0" cellpadding="0" border="0">';
			html += '		<tr>';
			html += '			<td class="serial">';
			html += '				<img name="service_icon" id="yahooservice_icon_'+keyword[i]+'" src="/icons/expand.gif"/>';
			html += '			</td>';
			html += '			<td class="service">Yahoo</td>';
			html += '			<td class="keyword">';
			html += '				<p id="yahooservice_keyword_'+keyword[i]+'"></p>';
			html += '			</td>';
			html += '			<td class="rank">';
			html += '				<p id="yahooservice_rank_'+keyword[i]+'"></p>';
			html += '			</td>';
			html += '		</tr>';
			html += '	</table>';
			html += '	<table cellspacing="0" cellpadding="0" border="0" class="details" id="yahooservice_details_'+keyword[i]+'" style="display:none">';
			html += '		<tr>';
			html += '			<td class="link">';
			html += '				<div id="yahooservice_href_'+keyword[i]+'">';
			html += '				</div>';
			html += '			</td>';
			html += '		</tr>';
			html += '	</table>';
			html += '</li>';
			html += '<li>';
			html += '	<table cellspacing="0" cellpadding="0" border="0">';
			html += '		<tr>';
			html += '			<td class="serial">';
			html += '				<img name="service_icon" id="bingservice_icon_'+keyword[i]+'" src="/icons/expand.gif"/>';
			html += '			</td>';
			html += '			<td class="service">Bing</td>';
			html += '			<td class="keyword">';
			html += '				<p id="bingservice_keyword_'+keyword[i]+'"></p>';
			html += '			</td>';
			html += '			<td class="rank">';
			html += '				<p id="bingservice_rank_'+keyword[i]+'"></p>';
			html += '			</td>';
			html += '		</tr>';
			html += '	</table>';
			html += '	<table cellspacing="0" cellpadding="0" border="0" class="details" id="bingservice_details_'+keyword[i]+'" style="display:none">';
			html += '		<tr>';
			html += '			<td class="link">';
			html += '				<div id="bingservice_href_'+keyword[i]+'">';
			html += '				</div>';
			html += '			</td>';
			html += '		</tr>';
			html += '	</table>';
			html += '</li>';
			document.getElementById('rankresults').innerHTML += html;
			
			this.googlerank(keyword[i],url);
			this.yahoorank(keyword[i],url);
			this.bingrank(keyword[i],url);
		}
		
		// attach events
		var service_icons = document.getElementsByName('service_icon');
		for(var i=0;i<service_icons.length;i++) {
			document.getElementById(service_icons[i].id).addEventListener('click', function(){
				pr.showprdetails(this);
			});
		}
	},
	fliptabs: function(action) {
		// Set all classed to ""
		if(document.getElementById('doublemenu').style.display == "block") {
			document.getElementById('dmbl').className = "";
			document.getElementById('dmpr').className = "";
			document.getElementById('backlinks').style.display = "none";
			document.getElementById('pageranks').style.display = "none";
			
			if(action == "backlinks") {
				document.getElementById('dmbl').className = "selected";
				document.getElementById('backlinks').style.display = "block";
				
				// Enable PR
				//document.getElementById('pr').style.display = "block";
				//document.getElementById('export2xls').style.display = "none";
				
				this.backlinks();
			}
			else if(action == "pageranks") {
				document.getElementById('dmpr').className = "selected";
				document.getElementById('pageranks').style.display = "block";
				
				// Enable Export2XLS
				//document.getElementById('export2xls').style.display = "block";
				//document.getElementById('pr').style.display = "none";
				
				this.pageranks();
			}
		}
	},
	showaddkeyword: function() {
		document.getElementById('addkeywords').style.display = "block";
	},
	hideaddkeyword: function() {
		document.getElementById('addkeywords').style.display = "none";
	},
	export2xls: function() {
		alert(this.fread(pr.appdir+"/reports/abhinavsingh.com.xls","READ"));
	},
	onkeypress: function(e) {
		if(document.getElementById('url').value.length < 8 && document.getElementById('url').value != 'http://') {
			document.getElementById('url').value = 'http://';
		}
		if(e.keyCode==13) {
			pr.backlinks();
			return false;
		}
	}
}
